          #include <P16F628A.INC>
            LIST        p=16F628A     
            __CONFIG    H'3F10'             ; 
                                     
            
Sec           equ         20h               ;    
Sec1          equ         21h               ; 
Sec2          equ         22h               ;   
scetbit       equ         23h               ;       spi
dat_ind       equ         24h               ;       spi
adr_ind       equ         25h               ;       spi
dat_tmp       equ         26h               ;       spi
adr_tmp       equ         27h               ;       spi

#DEFINE       din         PORTB,5           ;    MAX7219
#DEFINE       cs          PORTB,6           ;   MAX7219
#DEFINE       clk         PORTB,7           ;   MAX7219

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              org         0000h             ;     0000h
              goto        Start             ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                            
Start         movlw       b'01000000'       ;    B
              movwf       PORTB
              
              movlw       b'00000111'       ; 
              movwf       CMCON

              bsf         STATUS,RP0        ; 1-     
              movlw       b'00011111'       ;  \  B  
              movwf       TRISB             ;RB0-RB4  ,   
              bcf         STATUS,RP0        ; 0-                 
              
              call        init_lcd          ;   (MAX7219) 
              
met_1         movlw       0x09              ;    
              movwf       adr_ind           ;
              movlw       0x00              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x08              ;  7-  (  HG8)
              movwf       adr_ind           ;
              movlw       b'01110111'       ;        'A'
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x07              ;  6-  (  HG7)
              movwf       adr_ind           ;
              movlw       b'00110111'       ;        'H'
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x06              ;  5-  (  HG6)
              movwf       adr_ind           ;
              movlw       b'01001111'       ;        'E'
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x05              ;  4-  (  HG5)
              movwf       adr_ind           ;
              movlw       b'01100111'       ;        'P'
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x04              ;  3-  (  HG4)
              movwf       adr_ind           ;
              movlw       b'00011111'       ;        'b'
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x03              ;  2-  (  HG3)
              movwf       adr_ind           ;
              movlw       b'00001101'       ;        'c'
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x02              ;  1-  (  HG2)
              movwf       adr_ind           ;
              movlw       b'00111101'       ;        'd'
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x01              ;  0-  (  HG1)
              movwf       adr_ind           ;
              movlw       b'00011101'       ;        'o'
              movwf       dat_ind           ;
              call        send              ;

              call        paus_2s           ;   1 

              movlw       0x09              ;    
              movwf       adr_ind           ;
              movlw       0xFF              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x08              ;  7-  (  HG8)
              movwf       adr_ind           ;
              movlw       0x00              ;  0     (  0)
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x07              ;  6-  (  HG7)
              movwf       adr_ind           ;
              movlw       0x01              ;  1     (  1)
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x06              ;  5-  (  HG6)
              movwf       adr_ind           ;
              movlw       0x02              ;  2     (  2)
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x05              ;  4-  (  HG5)
              movwf       adr_ind           ;
              movlw       0x03              ;  3     (  3)
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x04              ;  3-  (  HG4)
              movwf       adr_ind           ;
              movlw       0x04              ;  4     (  4)
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x03              ;  2-  (  HG3)
              movwf       adr_ind           ;
              movlw       0x05              ;  5     (  5)
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x02              ;  1-  (  HG2)
              movwf       adr_ind           ;
              movlw       0x06              ;  6     (  6)
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x01              ;  0-  (  HG1)
              movwf       adr_ind           ;
              movlw       0x07              ;  7     (  7)
              movwf       dat_ind           ;
              call        send              ;
           
              call        paus_2s           ;   1 
              goto        met_1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  (MAX7219)

init_lcd      call        pauslcd           ;   2 
              movlw       0x0F              ;  
              movwf       adr_ind           ;
              movlw       0x00              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0C              ;    
              movwf       adr_ind           ;
              movlw       0x01              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0A              ;   31/32
              movwf       adr_ind           ;
              movlw       0x07              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x09              ;    
              movwf       adr_ind           ;
              movlw       0xFF              ;
              movwf       dat_ind           ;
              call        send              ;

              movlw       0x0B              ; 8 
              movwf       adr_ind           ;
              movlw       0x07              ;
              movwf       dat_ind           ;
              call        send              ;
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  2-  ( )   (MAX7219)   SPI

send          bcf         cs                ;    CS
              movlw      .8                 ;    adr_ind
              movwf      scetbit            ;
              movf       adr_ind,W          ;      
              movwf      adr_tmp            ;
povtor        bcf        clk                ;
              btfsc      adr_tmp,7          ;
              bsf        din                ;
              btfss      adr_tmp,7          ;
              bcf        din                ;
              bsf        clk                ;
              rlf        adr_tmp,F          ;
              decfsz     scetbit,F          ;
              goto       povtor             ;
             
              movlw      .8                 ;    dat_ind
              movwf      scetbit            ;
              movf       dat_ind,W          ;      
              movwf      dat_tmp            ;
povtr1        bcf        clk                ;
              btfsc      dat_tmp,7          ;
              bsf        din                ;
              btfss      dat_tmp,7          ;
              bcf        din                ;
              bsf        clk                ;
              rlf        dat_tmp,F          ;
              decfsz     scetbit,F          ;
              goto       povtr1             ;
              bcf        clk                ;
              bsf        cs                 ;  1    CS                 
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

pauslcd       movlw       .4                ;  2 
              movwf       Sec1              ;
p2            movlw       .166              ;
              movwf       Sec               ;
p1            decfsz      Sec,F             ;
              goto        p1                ;
              decfsz      Sec1,F            ;
              goto        p2                ;
              return                        ;  
                                            
paus_2s       movlw       .10                ;  2 
              movwf       Sec2              ;
p_3           movlw       .255              ;
              movwf       Sec1              ;
p_2           movlw       .255              ;
              movwf       Sec               ;
p_1           decfsz      Sec,F             ;
              goto        p_1               ;
              decfsz      Sec1,F            ;
              goto        p_2               ;
              decfsz      Sec2,F            ;
              goto        p_3               ;
              return                        ;  
                                            
              end                           ;  
                                            ;
